/* file.h */

#define FT_ILS          0
#define FT_C            1
#define FT_TRN          2
#define FT_LST          3
#define FT_PLT          4
#define FT_SND	        5
#define FT_NOH	        6
#define FT_MAT	        7
#define FT_WAV	        8
#define FT_TOK	        9
#define FT_ADF	        10
#define NFT	        11	/* number of file types */

#define DT_UNSIGNED_8	0
#define DT_MULAW_8	1
#define DT_LINEAR_8	2
#define DT_LINEAR_16	3
#define DT_LINEAR_24	4
#define DT_LINEAR_32	5
#define DT_FLOAT	6
#define DT_DOUBLE	7
#define NDT	        8	/* number of data types */

#define ILSHDSZ 128
#define TRNHDSZ 128

#define BITS    8
#define DACZ    128
#define NSPB    256		/* number of samples per block */
#define NBLKS   ils_hdr[5]	/* number of disk blocks */
#define ICHAN   ils_hdr[57]	/* beginning A-D channel */
#define NCHAN   ils_hdr[58]	/* number of A-D channels */
#define SE      ils_hdr[60]	/* sampling frequency exponent */
#define SF      ils_hdr[61]	/* sampling frequency */
#define TYPE    ils_hdr[62]	/* type of file */
#define INIT    ils_hdr[63]	/* initialization flag */
#define SDF     -32000		/* sampled data file */

typedef struct {
    char    vkey[4];
    long    vnum, vadr, vdar, vstm;
    short   vsmn, vsmx;
    char    vrsrv[TRNHDSZ - (4 + 4 * sizeof(long) + 2 * sizeof(short))];
}       TRNHDR;
typedef struct {
    short   format;
    short   channels;
    long    samp_sec;
    long    byte_sec;
    short   block_align;
    short   bits_smp;
}   WAV_fmt;
typedef struct {
    long key;	/* must be equal to snd_key */
    long ofst;	/* Offset to raw data */
    long size;	/* Number of bytes of data */
    long code;	/* Data format code */
    long rate;	/* Sample rate */
    long chan;	/* Number of channels */
    char info[4];	/* Information about the sound. */
}   SND_fmt;
typedef struct {
    long key[2];
    long npts;
    long cntr;
    unsigned short chan;
    unsigned short bits;
    unsigned short code;
    float rate;
    long peak;
    char fill[466];
    float gain1;
    float gain2;
    float vrms;
    float dbref;
}   ADF_fmt;

extern char adf_key[];
extern char *btni_key;
extern char *trn_key;
extern int file_type;
extern long snd_key;
