/* g_w32.c */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <time.h>
#include <windows.h>
#include <windowsx.h>
#include "waved.h"
#include "video.h"
#include "memory.h"
#include "fk.h"

#define Ctrl_C      3
#define MAXNSS      1
#define TBSZ        13

#ifndef SIGPTRDEF
#ifdef HUGE_PTR
typedef short huge *SIGPTR;
#else
typedef short *SIGPTR;
#endif /* HUGE_PTR */
#define SIGPTRDEF
#endif  /* SIGPTRDEF */

void    window_max();
void    zoom_in();
void    zoom_out();
void    pan_left();
void    pan_right();
void    pan_left_sm();
void    pan_right_sm();
void    window_edit();
void    toolbar();
void    beep();
void    leave();
void    g_bar(int, int, int, int, int);
void    g_draw(int, int, int);
void    g_line(int, int, int, int, int);
void    g_move(int, int);
void    g_text(int, int, char *);
void    g_settextclr(int, int);
void    g_setxor(int);
void    gr_gettp(int *, int *);
void    gr_putc(int, int, int);
void    gr_recto(int, int, int, int, int);
void    gr_rectf(int, int, int, int, int);
void    waved(int, char **);

extern  thru;
extern  monoflg;

int     grfcrd;			/* indicates type of graphic card */
int     scrszx, scrszy;		/* screen size x and y */
int     boxx1, boxy1;		/* box lower-left corner */
int     boxx2, boxy2;		/* box upper-right corner */
int     cw1x1, cw1y1;		/* closeup window 1 lower-left  corner */
int     cw1x2, cw1y2;		/* closeup window 1 upper-right corner */
int     cw2x1, cw2y1;		/* closeup window 2 lower-left  corner */
int     cw2x2, cw2y2;		/* closeup window 2 upper-right corner */
int     hlpx1, hlpy1;		/* help screen lower-left  corner */
int     hlpx2, hlpy2;		/* help screen upper-right corner */
int     lvlx1, lvly1;		/* level window lower-left  corner */
int     lvlx2, lvly2;		/* level window upper-right corner */
int     wavcol; 		/* wave text color */
int     tlbcol, stscol;		/* toolbar and status text color */
int     boxcol, active;		/* nonactive and active box colors */
int     csrcol, scwcol;		/* cursor and scroll window colors */
int     mkfgc, scbgc;		/* marker foregound/screen background colors */
int     hsfgc, hsbgc;		/* help screen foreground/background colors */
int     msfgc, msbgc;		/* help screen foreground/background colors */
int     wnfgc, wnbgc;		/* window number foreground/background colors */
int     blfgc, blbgc;		/* box label foreground/background colors */
int     bmfgc, bmbgc;		/* box message foreground/background colors */
int     clfgc, clbgc;		/* closeup label foreground/background colors */
int     msgx, msgy;		/* message starting position */
int     stsx, stsy;		/* status starting position */
int     bxlx, bxly;		/* box label starting position */
int     bxmx, bxmy;		/* box message starting position */
int     cw1x, cw1y;		/* closeup window 1 label starting position */
int     cw2x, cw2y;		/* closeup window 2 label starting position */
int     cumx, cumy;		/* cursor message starting position */
int     ch_wd, ch_ht, ln_sp;	/* character width, height, and line spacing */

static int mouse_present = 0;
static int mouse_sh = 1;
static int mouse_on = 0;
static int eventq = 0;
static int mouse_evnt = 0;
static int cu_on = 0, cu_h = 0, cu_x = 0, cu_y = 0, cu_c = 0;
static int sb_on = 0, sb_x1 = 0, sb_y1 = 0, sb_x2 = 0, sb_y2 = 0, sb_c = 0;
static int ms_lb = 0, ms_rb = 0, ms_cx = 0, ms_cy = 0;
static int nss = 0;
static int firstime = 1;
static int txt_bgc = 0;
static int txt_fgc = 0;

/*---------------------------------------------------------------------*/

void
g_cursor_del()
{
    if (cu_on) {		/* remove the old line */
	g_setxor(1);
	g_line(cu_x, cu_y, cu_x, cu_y + cu_h, cu_c);
	g_setxor(0);
	cu_on = 0;
    }
}

void
g_cursor_init(h, col)
{
    g_cursor_del();
    cu_h = h;
    cu_c = col;
}

void
g_cursor_move(x, y)
{
    g_cursor_del();
    g_setxor(1);
    cu_x = x;
    cu_y = y;
    g_line(cu_x, cu_y, cu_x, cu_y + cu_h, cu_c);
    g_setxor(0);
    cu_on = 1;
}

void
g_sb_del()
{
    if (sb_on != 0) {
	g_setxor(1);
	g_line(sb_x1, sb_y1, sb_x2, sb_y1, sb_c);
	g_line(sb_x2, sb_y1, sb_x2, sb_y2, sb_c);
	g_line(sb_x2, sb_y2, sb_x1, sb_y2, sb_c);
	g_line(sb_x1, sb_y2, sb_x1, sb_y1, sb_c);
	g_setxor(0);
	sb_on = 0;
    }
}

void
g_sb_move(x1, y1, x2, y2, color)
{
    g_sb_del();
    g_setxor(1);
    sb_x1 = x1;
    sb_y1 = y1;
    sb_x2 = x2;
    sb_y2 = y2;
    sb_c = color;
    g_line(sb_x1, sb_y1, sb_x2, sb_y1, sb_c);
    g_line(sb_x2, sb_y1, sb_x2, sb_y2, sb_c);
    g_line(sb_x2, sb_y2, sb_x1, sb_y2, sb_c);
    g_line(sb_x1, sb_y2, sb_x1, sb_y1, sb_c);
    g_setxor(0);
    sb_on = 1;
}

void
g_erase(int x, int y, int n)
{
    g_bar(x, y - ch_ht, x + ch_wd * n, y - ch_ht + ln_sp, txt_bgc);
}

void
g_txt_cur(int x, int y)
{
    y += ln_sp - ch_ht - 1;
    g_line(x, y, x + ch_wd, y, txt_fgc);
}

void
g_text_dif(x, y, s, t)
char   *s, *t;
{
    char c[2], temp;
    int i, ns, nt;

    ns = strlen(s);
    nt = strlen(t);    
    c[1] = '\0';
    for (i = 0; i < ns || i < nt; i++) {
        c[0] = (i < ns) ? s[i] : ' ';
        temp = (i < nt) ? t[i] : ' ';
        if (temp != c[0])
            g_text(x + i * ch_wd, y, c);
    }
}

void
g_bar(int x1, int y1, int x2, int y2, int color)
{
    gr_rectf(x1, y1, x2, y2, color);
}

void
g_box(int x1, int y1, int x2, int y2, int color)
{
    gr_recto(x1, y1, x2, y2, color);
}

/* g_drawmark - put one marker on the screen */

void 
g_drawmark(int x, int y, int c)
{
    char    ch[2];
    int     x1, y1, x2, y2;

    if (x < 0 || x >= scrszx)
	return;
    if (y < 0 || y >= scrszy)
	return;
    if (c < 0 || c >= 26)
	return;
    g_cursor_del();
    g_setxor(1);
    x1 = x;
    y1 = y;
    x2 = x1;
    y2 = y + 8;
    g_line(x1, y1, x2, y2, mkfgc);
    x1 -= 3;
    y1 = y + 18;
    ch[0] = 'A' + c;
    ch[1] = '\0';
    g_settextclr(mkfgc, -1);
    g_text(x1, y1, ch);
    g_setxor(0);
    g_cursor_move(cu_x, cu_y);
}

void
g_drawwave(pbuf, npts, nchn, xpix, ypix, xofst, yofst, yrange, yzero, color)
SIGPTR  pbuf;
int     xpix, ypix, xofst, yofst, color;
long    npts, yrange, yzero;
{
    int     x, y, lastx, ymn, ymx, i = 0;
    int     yval, ymin, ymax, ytop, ybot;
    long    x0, x1, x2, y0, y1, y2, icount;

    if (npts < 1 || nchn < 1 || yrange < 2)
	return;
    x1 = xpix;
    x2 = npts;
    y1 = ypix - 1;
    y2 = yrange - 1;
    ytop = yofst - ypix / 2;
    ybot = yofst + ypix / 2;

    x0 = xofst;
    y0 = yofst + (yzero * y1) / y2;

    x = (int) x0;
    yval = pbuf[i];
    i += nchn;
    y = (int) (y0 - (yval * y1) / y2);
    y = limit(ytop, y, ybot);
    g_move(x, y);
    if (npts < 2) {
	g_draw(x, y, color);
    } else if (x2 < x1 * 2) {
	for (icount = 1; icount < npts; icount++) {
	    x = (int) (x0 + (icount * x1) / x2);
	    yval = pbuf[i];
	    i += nchn;
	    y = (int) (y0 - (yval * y1) / y2);
	    y = limit(ytop, y, ybot);
	    g_draw(x, y, color);
	}
    } else {
	for (icount = 1; icount < npts;) {
	    ymin = yval;
	    ymax = yval;
	    lastx = x;
	    while (x == lastx && icount < npts) {
		x = (int) (x0 + (icount++ * x1) / x2);
                yval = pbuf[i];
                i += nchn;
		if (yval < ymin)
		    ymin = yval;
		if (yval > ymax)
		    ymax = yval;
	    }
	    ymn = (int) (y0 - (ymin * y1) / y2);
	    ymx = (int) (y0 - (ymax * y1) / y2);
	    if (ymn > ybot)
		ymn = ybot;
	    if (ymx < ytop)
		ymx = ytop;
	    gr_rectf(x, ymx, x, ymn, color);
	}
    }
}

static void
setcol()
{
    wavcol = 15;		/* wave color */
    stscol = 6; 		/* status text color */
    tlbcol = 7; 		/* toolbox text color */
    boxcol = 8;			/* nonactive box color */
    active = 5;			/* active box color */
    csrcol = 7;			/* cursor color */
    scwcol = 8;			/* scroll window color */
    mkfgc = 14;			/* marker color */
    scbgc = 0;			/* screen background color */
    msfgc = 14;			/* message forground color */
    msbgc = 0;			/* message background color */
    wnbgc = 1;			/* window background color */
    hsfgc = 15;			/* help screen foreground color */
    hsbgc = 6;			/* help screen background color */
    blfgc = 14;			/* box label foreground color */
    blbgc = 1;			/* box label background color */
    bmfgc = 14;			/* box message foreground color */
    bmbgc = 1;			/* box message background color */

}

static void
setpos()
{
    int     botscr, h;

    botscr = scrszy - 1;
    h = ln_sp;

    lvlx1 = 300;
    lvly1 = 20;
    lvlx2 = 400;
    lvly2 = botscr - 20;

    bxly = boxy1 - 2;		/* box label starting position, y */
    cumx = scrszx / 2;		/* cursor message starting position, x */
    cumy = bxly;		/* cursor message starting position, y */
    stsx = boxx1;		/* status starting position, x */
    stsy = botscr - 2;		/* status starting position, y */
    msgx = stsx;		/* message starting position, x */
    msgy = stsy - ln_sp;	/* message starting position, y */
}

void
beep()
{
}

/**********************************************************************/

static int  keyval = 0, draw = 0;
static int  xor = R2_COPYPEN;
//static int  xwin = 640, ywin = 480;
static int  xpos = 0, ypos = 0;
static int ctrl = 0, shft = 0;
static HBITMAP hOBM, hNBM;
static HBRUSH  hbr[16];
static HDC hDCMem = NULL;
static HFONT hfnt, hOldFont;      
static HWND hwnd;
static HPEN hpen[16];
static RECT lpSize;
static struct {
    HDC hdc;
    HBITMAP hbm;
    int w, h;
} scrn[MAXNSS];

static long
rgb_color(int c)
{
    static struct {
        short int r, g, b;
    } ct[16] = {
        0, 0, 0,	/* black      */
        0, 0, 170,	/* blue       */
        0, 170, 0,	/* green      */
        0, 170, 170,	/* cyan       */
        170, 0, 0,	/* red        */
        170, 0, 170,	/* magenta    */
        170, 85, 0,	/* brown      */
        170, 170, 170,	/* lt grey    */
        85, 85, 85,	/* dk grey    */
        85, 85, 255,	/* lt blue    */
        85, 255, 85,	/* lt green   */
        85, 255, 255,	/* lt cyan    */
        255, 85, 85,	/* lt red     */
        255, 85, 255,	/* lt magenta */
        255, 255, 85,	/* yellow     */
        255, 255, 255,	/* white      */
    };

    return (RGB(ct[c].r, ct[c].g, ct[c].b));
}


void
g_init()
{
    int i;
    HDC  hdc;
    TEXTMETRIC tm;

    hdc = GetDC(hwnd);
    GetClientRect(hwnd, (LPRECT) &lpSize);
    scrszx = lpSize.right - lpSize.left;
    scrszy = lpSize.bottom - lpSize.top;
    if (hDCMem == NULL) {
        hDCMem = CreateCompatibleDC(hdc);
        hNBM = CreateCompatibleBitmap(hdc, scrszx, scrszy); 
        for (i = 0; i < 16; i++) {
            hpen[i] = CreatePen(PS_SOLID, 0, rgb_color(i));
            hbr[i] = CreateSolidBrush(GetNearestColor(hdc, rgb_color(i)));
        }
    }
    hOBM = SelectObject(hDCMem, hNBM);
    SelectPen(hDCMem, hpen[0]);
    hfnt = GetStockFont(ANSI_FIXED_FONT); 
    hOldFont = SelectObject(hDCMem, hfnt);     
    ReleaseDC(hwnd, hdc);

    GetTextMetrics(hDCMem, &tm);
    ch_wd = tm.tmAveCharWidth;
    ch_ht = tm.tmAscent;
    ln_sp = tm.tmHeight + 2;

    setcol();

    cu_on = 0;
    if (firstime) {
	setpos();
	firstime = 0;
    }
    gr_rectf(0, 0, scrszx, scrszy, scbgc);
}

void
g_close()
{
    DestroyWindow(hwnd);
}

void
gr_quit()
{
    int i;
    
    for (i = 0; i < nss; i++) {
        ReleaseDC(hwnd, scrn[i].hdc);
        DeleteObject(scrn[i].hbm);
    }
    nss = 0;
    for (i = 0; i < 16; i++) {
        DeleteObject(hbr[i]);
        DeleteObject(hpen[i]);
    }
    DeleteObject(hNBM);
    DeleteDC(hDCMem);
    hDCMem = NULL;
}

void
g_invalidate(int x, int y, int w, int h)
{
    RECT r;
    
    SetRect(&r, x, y, x + w, y + h);
    InvalidateRect(hwnd, &r, FALSE);
}

void
g_settextclr(int fg, int bg)
{
    if (bg < 0) {
        (void) SetBkMode(hDCMem, TRANSPARENT);
    } else {
        (void) SetBkMode(hDCMem, OPAQUE);
        (void) SetBkColor(hDCMem, rgb_color(bg));
   }
    (void) SetTextColor(hDCMem, rgb_color(fg));
    txt_fgc = fg;
    txt_bgc = bg;
}
	
void
g_text(int x, int y, char *s)
{
    int n;
    
    n = strlen(s);
    TextOut(hDCMem, x, y - ch_ht, s, n);
    g_invalidate(x, y - ch_ht, x + ch_wd * n, y - ch_ht + ln_sp);
    xpos = x + ch_wd * n;
    ypos = y;
}

void
gr_putc(int x, int y, int c)
{
    char s[2];
    
    s[0] = (char) c;
    s[1] = '\0';
    g_text(x, y, s);
}

void
g_gettp(int *x, int *y)
{
    *x = xpos;
    *y = ypos;
}

void
g_setxor(int m)
{
    xor = m ? R2_XORPEN : R2_COPYPEN;
    SetROP2(hDCMem, xor);
}

void
g_line(int x1, int y1, int x2, int y2, int c)
{
    HDC hdc;
    
    MoveToEx(hDCMem, x1, y1, NULL);
    if (x1 != x2 || y1 != y2) {
        SelectPen(hDCMem, hpen[c]);
        LineTo(hDCMem, x2, y2);
    } else {
        SetPixel(hDCMem, x2, y2, rgb_color(c));
    }
    if (!draw) {
        hdc = GetDC(hwnd);
        SetROP2(hdc, xor);
        MoveToEx(hdc, x1, y1, NULL);
        if (x1 != x2 || y1 != y2) {
            SelectPen(hdc, hpen[c]);
            LineTo(hdc, x2, y2);
        } else {
            SetPixel(hdc, x2, y2, rgb_color(c));
        }
        ReleaseDC(hwnd, hdc);
    }
    xpos = x2;
    ypos = y2;
}

void
g_move(int x, int y)
{
    xpos = x;
    ypos = y;
}

void
g_draw(int x, int y, int c)
{
    draw = 1;
    g_line(xpos, ypos, x, y, c);
    draw = 0;
}

void
gr_recto(int x1, int y1, int x2, int y2, int c)
{
    g_line(x1, y1, x2, y1, c);
    g_line(x2, y1, x2, y2, c);
    g_line(x2, y2, x1, y2, c);
    g_line(x1, y2, x1, y1, c);
    chkevent();
}

void
gr_rectf(int x1, int y1, int x2, int y2, int c)
{
    RECT    r;

    r.left = (x1 < x2) ? x1 : x2;
    r.right = (x1 < x2) ? x2 : x1;
    r.top = (y1 < y2) ? y1 : y2;
    r.bottom = (y1 < y2) ? y2 : y1;
    r.bottom++;
    r.right++;
    FillRect(hDCMem, &r, hbr[c]);
    InvalidateRect(hwnd, &r, FALSE);
}

void
gr_clrs()
{
    gr_rectf(0, 0, scrszx, scrszy, scbgc);
}


void
gr_mstatus(int *mlb, int *mrb, int *mcx, int *mcy)
{
    *mlb = ms_lb;
    *mrb = ms_rb;
    *mcx = ms_cx;
    *mcy = ms_cy;
}

void
gr_xshft(int y1, int y2, int nb)
{
    int x1, x2, y, w, h, b;

    if (nb > 0) {
    	b = nb * MNBS;
        x1 = 0;
        x2 = b;
    } else if (nb < 0) {
    	b = -nb * MNBS;
        x1 = b;
        x2 = 0;
    } else {
        return;
    }
    w = scrszx - b;
    if (y2 > y1) {
        h = y2 - y1 + 1;
        y = y1;
    } else {
        h = y1 - y2 + 1;
        y = y2;
    }
    BitBlt(hDCMem, x2, y, w, h, hDCMem, x1, y, SRCCOPY); 
    g_invalidate(x2, y, w, h);
}

int
g_savscr(x1, y1, x2, y2)
{
    int w, h;

    if (nss >= MAXNSS)
	return (-1);


    w = x2 - x1 + 1;
    h = y2 - y1 + 1;
    scrn[nss].w = w;
    scrn[nss].h = h;
    scrn[nss].hdc = CreateCompatibleDC(hDCMem);
    scrn[nss].hbm = CreateCompatibleBitmap(hDCMem,w,h); 
    SelectObject(scrn[nss].hdc, scrn[nss].hbm);
    BitBlt(scrn[nss].hdc, 0, 0, w, h, hDCMem, x1, y1, SRCCOPY); 

    return (nss++);
}

void
g_rstscr(int ss, int x1, int y1)
{
    int w, h;

    if (ss < 0 || ss >= nss || ss >= MAXNSS)
	return;

    w = scrn[ss].w;
    h = scrn[ss].h;
    BitBlt(hDCMem, x1, y1, w, h, scrn[ss].hdc, 0, 0, SRCCOPY); 
    g_invalidate(x1, y1, w, h);
    ReleaseDC(hwnd, scrn[ss].hdc);
    DeleteObject(scrn[ss].hbm);

    nss--;
}

/*---------------------------------------------------------------------*/

void
paint_scr(HWND hw, PAINTSTRUCT ps)
{
    HDC   hdc;
    INT  x = 0, y = 0, w = scrszx, h = scrszy;

    hdc = GetDC(hw);
    x = ps.rcPaint.left;
    y = ps.rcPaint.top;
    w = ps.rcPaint.right - ps.rcPaint.left;
    h = ps.rcPaint.bottom - ps.rcPaint.top;
    BitBlt(hdc, x, y, w, h, hDCMem, x, y, SRCCOPY); 
    ReleaseDC(hw, hdc);
}

/*---------------------------------------------------------------------*/

LRESULT CALLBACK 
WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps ;

    switch (iMsg) {

    case WM_CREATE:
        return 0 ;

//    case WM_SIZE:
//        SetWindowPos(hwnd, HWND_TOP, 0, 0, xwin, ywin, SWP_NOMOVE);
//        return 0 ;

    case WM_PAINT :
        BeginPaint(hwnd, (LPPAINTSTRUCT)&ps);
        paint_scr(hwnd, ps);
        EndPaint(hwnd, (LPPAINTSTRUCT)&ps);
        return 0 ;

    case WM_CHAR:
        keyval = wParam;
        if (keyval == Ctrl_C) {
            thru = 1;
        }
        if (keyval == '\t' && shft)
            keyval = FK_Shift_Tab;
        return 0 ;

    case WM_KEYDOWN:
        if (wParam == VK_CONTROL)
            ctrl = 1;
        else if (wParam == VK_SHIFT)
            shft = 1;
        if (wParam == VK_F1)
            keyval = FK_F1;
        else if (wParam == VK_F2)
            keyval = FK_F2;
        else if (wParam == VK_F3)
            keyval = FK_F3;
        else if (wParam == VK_F4)
            keyval = FK_F4;
        else if (wParam == VK_F5)
            keyval = FK_F5;
        else if (wParam == VK_F6)
            keyval = FK_F6;
        else if (wParam == VK_F7)
            keyval = FK_F7;
        else if (wParam == VK_F8)
            keyval = FK_F8;
        else if (wParam == VK_RIGHT)
            keyval = ctrl ? FK_Ctrl_Right : shft ? '6' : FK_Right_Arrow;
        else if (wParam == VK_LEFT)
            keyval = ctrl ? FK_Ctrl_Left : shft ? '4' : FK_Left_Arrow;
        else if (wParam == VK_UP)
            keyval = FK_Up_Arrow;
        else if (wParam == VK_DOWN)
            keyval = FK_Down_Arrow;
        else if (wParam == VK_INSERT)
            keyval = FK_Ins;
        else if (wParam == VK_DELETE)
            keyval = FK_Del;
        else if (wParam == VK_HOME)
            keyval = ctrl ? FK_Ctrl_Home : FK_Home;
        else if (wParam == VK_END)
            keyval = ctrl ? FK_Ctrl_End : FK_End;
        else if (wParam == VK_PRIOR)
            keyval = FK_PgUp;
        else if (wParam == VK_NEXT)
            keyval = FK_PgDn;
        else
            break;
        return 0 ;

    case WM_KEYUP:
        if (wParam == VK_CONTROL)
            ctrl = 0;
        else if (wParam == VK_SHIFT)
            shft = 0;
        break;

    case WM_LBUTTONDOWN:
        keyval = MDL;
        return 0 ;
    
    case WM_RBUTTONDOWN:
        keyval = MDR;
        return 0 ;
    
    case WM_MOUSEMOVE:
        ms_cx = LOWORD(lParam);  // horizontal position of cursor 
        ms_cy = HIWORD(lParam);  // vertical position of cursor 
        keyval = MMV;
        return 0 ;

    case WM_ACTIVATE:
        SetCursor(LoadCursor (NULL, IDC_ARROW));
        ShowCursor(GET_WM_ACTIVATE_STATE(wParam, lParam));
        if (wParam && (!HIWORD(lParam)))
            SetFocus(hwnd);
        return 0 ;

    case WM_DESTROY :
        PostQuitMessage (0) ;
        return 0 ;
    }
    return DefWindowProc (hwnd, iMsg, wParam, lParam) ;
}

void
get_msg()
{
    MSG         msg;

    if (GetMessage (&msg, NULL, 0, 0)) {
        TranslateMessage (&msg);
        DispatchMessage (&msg);
    } else {
        keyval = Ctrl_C;
    }
    if (keyval == MMV && !(mouse_evnt & MS))
    	keyval = 0;
}

int
getevent()
{
    int         e;
    
    UpdateWindow(hwnd);
    while (keyval == 0)
    	get_msg();

    e = keyval;
    keyval = 0;
    
    return (e);
}

int
chkevent()
{
    MSG         msg;

    UpdateWindow(hwnd);
    if (keyval == 0)
        if (PeekMessage (&msg, NULL, 0, 0, PM_NOREMOVE))
            get_msg();

    return (keyval);
}

void
set_mouse_event(m)
{
    mouse_evnt = m;
}

int
lastevent()
{
    return (keyval);
}

void
get_mouse_location(int *x, int *y)
{
    *x = ms_cx;
    *y = ms_cy;
}

static char ea[2000], path[200];
static int  ep = 0;

static int
expand_arg(int ac, char *av[], char *s, int n)
{
    char *ap;
    int i, done, wc = 0, c, nf = 0;
    HANDLE  hnd;
    WIN32_FIND_DATA f;

    if (n >= 200)
    	return(0);

    for (i = 0; i < n; i++) {
    	c = s[i];
        if (c == '*' || c == '?')
            wc++;
    }
    if (wc == 0) {
        if (ep + n < 2000) {
            ap = ea + ep;
            strncpy(ap, s, n);
            ap[n] = '\0';
            av[ac] = ap;
            ep += n + 1;
            nf = 1;
        }
    } else {
        strncpy(path, s, n);
        path[n] = '\0';
	hnd = FindFirstFile(path, &f);
        for(i = n; i > 0; i--) {
            c = path[i - 1];
            if (c == '/' || c == '\\') {
                path[i] = '\0';
                break;
            }
        }
        if (i == 0)
            path[0] = '\0';
        done = (hnd == INVALID_HANDLE_VALUE);
	for (nf = 0; !done; nf++) {
            n = strlen(path) + strlen(f.cFileName);
            if (ep + n >= 2000)
                break;
            ap = ea + ep;
            sprintf(ap, "%s%s", path, (char *) f.cFileName);
            av[ac + nf] = ap;
            ep += n + 1;
	    done = !FindNextFile(hnd, &f);
	}
        FindClose(hnd);
    }
    return (nf);
}

int
parse_cs(char *cs, char *av[], char *pgm)
{
    char *cp, *ap;
    int qf, ac = 0;

    ep = 0;
    av[ac++] = pgm;
    cp = cs;
    while (*cp >= ' ') {
        if (qf = (*cp == '"'))
            cp++;
        ap = cp;
        if (qf) {
            while (*cp >= ' ' && *cp != '"')
                cp++;
        } else {
            while (*cp > ' ')
                cp++;
        }
        ac += expand_arg(ac, av, ap, (int)(cp - ap));
        if (qf && (*cp == '"'))
            cp++;
        while (*cp == ' ')
            cp++;
    }
    return (ac);
}

int WINAPI 
WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, 
    char * szCmdLine, int iCmdShow)
{
    int ac;
    char *av[MAXARG];
    RECT r;
    WNDCLASS	 wndclass ;
    static char szAppName[] = "WavEd" ;

    GetClientRect(GetDesktopWindow(), &r);

    wndclass.style         = 0 ;
    wndclass.lpfnWndProc   = WndProc ;
    wndclass.cbClsExtra    = 0 ;
    wndclass.cbWndExtra    = 0 ;
    wndclass.hInstance     = hInstance ;
    wndclass.hIcon         = LoadIcon (hInstance, szAppName) ;
    wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
    wndclass.hbrBackground = NULL;
    wndclass.lpszMenuName  = NULL ;
    wndclass.lpszClassName = szAppName ;
    RegisterClass (&wndclass) ;

    hwnd = CreateWindow (szAppName, /* window class name */
        szAppName,                  /* window caption */
        WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX, /* window style */
        r.left,                     /* initial x position */
        r.top,                      /* initial y position */
        (r.right - r.left),         /* initial x size */
        (r.bottom - r.top),         /* initial y size */
        NULL,                       /* parent window handle */
        NULL,                       /* window menu handle */
        hInstance,                  /* program instance handle */
        NULL) ;	                    /* creation parameters */

    ShowWindow (hwnd, iCmdShow) ;
    UpdateWindow (hwnd) ;
    
    ac = parse_cs(szCmdLine, av, szAppName);
    waved(ac, av);
    gr_quit();
    return (0);
}

/*********************************************************************/

#define TIMER_ID 1

void
timer_wait(long npts, long rate)
{
    int ms;
    
    ms = (int) (npts * 1000.0 / rate);
    if (ms > 0) {
        SetTimer(hwnd, TIMER_ID, ms, NULL);
        WaitMessage();
    }
}

void
timer_kill()
{
    KillTimer(hwnd, TIMER_ID);
}
