/* iod3 - I/O Device = TDT System II */

#include <dos.h>
#include "iod.h"
#include "wavtdt.h"

void stop_iod3();
int output_dac3(SIGPTR, long, long);
int input_adc3(SIGPTR, long, long);

extern qint cc, cpa[2], xbsel;
extern long xbtimeout;
typedef char xbstring[5];
extern unsigned char xbcode[XB_MAX_DEV_TYPES + 1][XB_MAX_OF_EACH_TYPE + 1][2];
extern qint xb_eflag;
extern char xb_err[10][50];

long    aptimeout;
qint    mrmode;
qint    ap_eflag;
char    ap_err[10][100];
qint    intset[3];
qint    cp[3];

qint    cc;
qint    cpa[2];
qint    xln, xbsel;
unsigned char cmd[100];
char   *xcaller;
unsigned char xbcode[XB_MAX_DEV_TYPES + 1][XB_MAX_OF_EACH_TYPE + 1][2];
xbstring xbname[XB_MAX_DEV_TYPES + 1];
long    xbtimeout;
qint    xb_eflag;
char    xb_err[10][50];

int     q, qq;

char   *caller;
char   *lastcall;
char    emess[300];
char    apid[5][5];
qint    apsel, qerror;

qint    aps[3];
qint    dspcfg[3];
qint    dspadr[3];
qint    dspadrx[3];
qint    dspdat[3];
qint    dsppcrh[3];
qint    dsppcrx[3];
qint    dspsync[3];

int
init_iod3()
{
    adbits = 16;
    adzero = 0;

    if (!XB1init(USE_DOS)) {	/* XBUS Error! */
	return (-1);
    }
    if (!apinit(APa))		/* AP2 Error! */
	if (!apinit(APb)) {
	    return (-2);
	}
    trash();
    dropall();
    stop_iod = stop_iod3;
    output_dac = output_dac3;
    input_adc = input_adc3;
    return (0);
}

void
stop_iod3()
{
    (void) init_iod3();
    return;
}

int
output_dac3(buf, npts, rate)
SIGPTR  buf;
long    npts, rate;
{
    static int cur_buf = TDT_BUF2;

    if (npts <= 0)
	return (0);
    if (rate <= 20)
	return (1);

    adnpts = npts;
    allot16(cur_buf, npts);	/* Allocate DAMA buffer.		 */
    DD1clear(1);		/* Program DD1 with required params 	 */
    DD1srate(1, clockrate_to_srate(rate));
    DD1npts(1, npts);
    DD1mode(1, DAC1);
    push16((qint *) buf, npts);
    qpop16(cur_buf);
    play(cur_buf);
    DD1arm(1);

    DD1go(1);
    do {
	if (_kbhit())
	    DD1stop(1);
    } while (DD1status(1));	/* Wait until conversion is finished.	 */
    stop_iod3();
    return (0);
}

int
input_adc3(buf, npts, rate)
SIGPTR  buf;
long    npts, rate;
{
    if (npts <= 0)
	return (0);
    if (rate <= 20)
	return (1);

    allot16(TDT_BUF1, npts);	/* Allocate DAMA buffer.		 */
    DD1clear(1);		/* Program DD1 with required params 	 */
    DD1srate(1, clockrate_to_srate(rate));
    DD1npts(1, npts);
    DD1mode(1, ADC1);
    tdt_record(TDT_BUF1);
    DD1arm(1);

    DD1go(1);			/* Start conversion from software	 */
    do {
	if (_kbhit())
	    DD1stop(1);
    } while (DD1status(1));	/* Wait until conversion is finished.	 */

    qpush16(TDT_BUF1);
    pop16((qint *) buf);
    stop_iod3();

    adnpts = npts;
    adrate = (long) (clockrate_to_srate(rate) * SRATE_DIVISOR);
    return (0);
}

/*--------------------------------------------------------------*/
/* Convert a clockrate value in points per second into an srate	*/
/* divisor as used in TDT clockrate functions.			*/
/*--------------------------------------------------------------*/

float 
clockrate_to_srate(long clockrate)
{
    return ((float) SRATE_DIVISOR / (float) clockrate);
}

qint 
XB1init(qint cptr)
{
    char   *s;
    qint    i, j, k, rn, pn, flag;
    qint    af;

    xb_eflag = 0;

    xbsel = 0;

    if (cptr > 0) {
	cc = cptr;
	if (cptr == 0x311)
	    cc = COM_APa;
	if (cptr == 0x312)
	    cc = COM_APb;
    } else {
	cc = COM_APa;
	s = getenv("XBCOM");
	if (s != NULL) {
	    if (!strcmp(s, "COM1") || !strcmp(s, "com1"))
		cc = COM1;
	    if (!strcmp(s, "COM2") || !strcmp(s, "com2"))
		cc = COM2;
	    if (!strcmp(s, "COM3") || !strcmp(s, "com3"))
		cc = COM3;
	    if (!strcmp(s, "COM4") || !strcmp(s, "com4"))
		cc = COM4;
	    if (!strcmp(s, "APb") || !strcmp(s, "apb"))
		cc = COM_APb;
	}
    }

    if (cc == COM_APb)
	xbsel = 1;

    af = 100;
    s = getenv("SPFACT");
    if (s != NULL) {
	sscanf(s, "%d", &af);
	if (af < 1)
	    af = 1;
	if (af > 1000)
	    af = 1000;
    }
    xbtimeout = (long) XB_TIMEOUT *af;

    switch (cc) {
    case COM1:
	cpa[xbsel] = COM1base;
	break;
    case COM2:
	cpa[xbsel] = COM2base;
	break;
    case COM3:
	cpa[xbsel] = COM3base;
	break;
    case COM4:
	cpa[xbsel] = COM4base;
	break;
    case COM_APa:
	cpa[xbsel] = 0x230;
	break;
    case COM_APb:
	cpa[xbsel] = 0x250;
    }

    for (i = 0; i < 20; i++)
	iosend(ERR_ACK);
    for (i = 0; i < 20; i++)
	iosend(SNOP);

    i = 1000;
    do {
	i--;
    } while (iorec() >= 0 && i > 0);

    if (i <= 0) {
	return (0);
    } else {
	for (i = 0; i < XB_MAX_DEV_TYPES; i++)
	    for (j = 0; j < XB_MAX_OF_EACH_TYPE; j++)
		xbcode[i][j][xbsel] = 0;

	for (i = 0; i < XB_MAX_DEV_TYPES; i++)
	    strcpy(xbname[i], "NU ");

	strcpy(xbname[PA4_CODE], "PA4");
	strcpy(xbname[SW2_CODE], "SW2");
	strcpy(xbname[CG1_CODE], "CG1");
	strcpy(xbname[SD1_CODE], "SD1");
	strcpy(xbname[ET1_CODE], "ET1");
	strcpy(xbname[PI1_CODE], "PI1");
	strcpy(xbname[UI1_CODE], "UI1");
	strcpy(xbname[WG1_CODE], "WG1");
	strcpy(xbname[PF1_CODE], "PF1");
	strcpy(xbname[TG6_CODE], "TG6");
	strcpy(xbname[PI2_CODE], "PI2");
	strcpy(xbname[WG2_CODE], "WG2");

	strcpy(xbname[DA1_CODE], "DA1");
	strcpy(xbname[AD1_CODE], "AD1");
	strcpy(xbname[DD1_CODE], "DD1");
	strcpy(xbname[AD2_CODE], "AD2");
	strcpy(xbname[AD3_CODE], "AD3");
	strcpy(xbname[DA3_CODE], "DA3");
	strcpy(xbname[PD1_CODE], "PD1");

	rn = 1;
	do {
	    flag = 0;
	    for (pn = 0; pn < 4; pn++) {
		iosend((rn << 2) + pn);
		iosend(IDENT_REQUEST);
		for (i = 0; i < XB_WAIT_FOR_ID; i++)
		    iosend(SNOP);
		j = iorec();
		if (j > 0 && j <= XB_MAX_DEV_TYPES) {
		    flag = 1;
		    k = 1;
		    do {
			if (xbcode[j][k][xbsel])
			    k++;
			else {
			    xbcode[j][k][xbsel] = (rn << 2) + pn;
			    k = 1000;
			}
		    } while (k <= XB_MAX_OF_EACH_TYPE);

		    if (k != 1000)
			showerr("Too many devices of single a type (increase XB_MAX_OF_EACH_TYPE).");
		}
	    }
	    rn++;
	} while (rn <= XB_MAX_NUM_RACKS && flag);
	return (1);
    }
}

/*
  Initializes DSP and PC systems.
 */

qint 
apinit(qint devtype)
{
    qint    i, j;
    char   *s;
    qint    af;

    mrmode = 0;
    ap_eflag = 0;
    caller = (char *) ("apinit");
    af = 100;
    s = getenv("SPFACT");
    if (s != NULL) {
	sscanf(s, "%d", &af);
	if (af < 1)
	    af = 1;
	if (af > 1000)
	    af = 1000;
    }
    aptimeout = (long) TIMEOUT *af;

    if (devtype != APa && devtype != APb)
	APerror("Illegal device type specified.  Use: APa or APb.");

    strcpy(apid[1], "APa");
    strcpy(apid[2], "APb");

    dsppcrx[1] = 0x22E;
    dspcfg[1] = 0x232;
    intset[1] = 0x233;

    dsppcrx[2] = 0x24E;
    dspcfg[2] = 0x252;
    intset[2] = 0x253;

    dspadr[1] = 0x220;
    dspadrx[1] = 0x22B;
    dspdat[1] = 0x222;
    dsppcrh[1] = 0x22A;
    dspsync[1] = 0x22C;
    cp[1] = 0x228;

    dspadr[2] = 0x240;
    dspadrx[2] = 0x24B;
    dspdat[2] = 0x242;
    dsppcrh[2] = 0x24A;
    dspsync[2] = 0x24C;
    cp[2] = 0x248;

    apsel = devtype & 0x03;
    i = 0;
    do {
	outportb(dspcfg[apsel], 4);
	for (j = 0; j < 1000; j++);
	outport(cp[apsel], 0);
	j = inport(dspdat[apsel]);
	outport(dspsync[apsel], ACK);
	j = inport(dspsync[apsel]);
	outportb(dspcfg[apsel], 6);
	for (j = 0; j < 1000; j++);
	outportb(dsppcrx[apsel], 3);
	outportb(dsppcrh[apsel], 2);
	outportb(dspcfg[apsel], 7);

	for (j = 0; j < 1000; j++);
	i++;
    } while ((inport(cp[apsel]) == ERRFLAG) && (i < 100));
    if (i >= 100)
	APerror("Board detected in but not resetting");
    if (inport(cp[apsel]) == READY) {
	outportb(dspcfg[apsel], 15);
	outportb(intset[apsel], 0);
	cmdout(INITx);
	aps[apsel] = 1;
    } else
	aps[apsel] = 0;

    return (aps[apsel]);
}

/******************************************************************
  Internal Error handler
  ----------------------------------------------------------------**/

void 
APerror(char *estr)
{
    long    jj;

    strcpy(emess, estr);

    jj = inport(cp[apsel]);

    if (jj == ERRFLAG)
	GetErr();
    else
	strcpy(lastcall, caller);

    ap_eflag = 1;
    sprintf(ap_err[0], " ");
    sprintf(ap_err[1], "   Array Processor Error >>>");
    sprintf(ap_err[2], "   Device:     %s", apid[apsel]);
    sprintf(ap_err[3], "   Operation:  %s", lastcall);
    sprintf(ap_err[4], "   Message:    %s", emess);
    sprintf(ap_err[5], "  ");
    sprintf(ap_err[6], "");

}

/******************************************************************
  Sends cmd to AP.  Checks for readiness to receive.
  ----------------------------------------------------------------**/
void 
cmdout(qint c)
{
    long    ii, jj;
    char    sss[200];

    ii = aptimeout;
    do {
	ii--;
	jj = inport(cp[apsel]);
	if (jj != inport(cp[apsel]))
	    jj = 0;
	else if (jj != inport(cp[apsel]))
	    jj = 0;
	else if (jj != inport(cp[apsel]))
	    jj = 0;
    } while (jj != READY && jj != ERRFLAG && ii > 0);

    if (ii == 0 || jj == ERRFLAG) {
	sprintf(sss, "Device not ready to receive command. (%ld)", jj);
	APerror(sss);
    }
    if (!ap_eflag) {
	outport(cp[apsel], c);
	lastcall = (char *) caller;
	ii = aptimeout;
	do {
	    ii--;
	    jj = inport(cp[apsel]);
	    if (jj != inport(cp[apsel]))
		jj = 0;
	    else if (jj != inport(cp[apsel]))
		jj = 0;
	    else if (jj != inport(cp[apsel]))
		jj = 0;
	} while (jj != RECEIVED && jj != READY && jj != ERRFLAG && ii > 0);

	if (ii == 0 || jj == ERRFLAG) {
	    sprintf(sss, "General device failure. (%ld)", jj);
	    APerror(sss);
	}
    }
}

/******************************************************************
  User recoverable error handler
  ----------------------------------------------------------------**/
void 
GetErr(void)
{
    qint    ll, jj, kk, aflag;
    long    ii;

    kk = 0;
    aflag = 0;
    outport(dspdat[apsel], ERRACK);
    for (ii = 0; ii < 1000; ii++);
    do {
	ii = aptimeout;
	do {
	    jj = inportb(dsppcrx[apsel]) & 0x20;
	    ii--;
	} while ((jj != 0x20) && (inport(cp[apsel]) != DONE) && (inport(cp[apsel]) != READY) && (ii != 0));
	if (ii == 0) {
	    strcpy(emess, "General device failure. (geterr)");
	    aflag = 1;
	}
	ll = inport(dspdat[apsel]) & 0xFF;
	if (jj == 0x20) {
	    emess[kk] = ll;
	    kk++;
	    emess[kk] = 0;
	    if (kk > 200) {
		strcpy(emess, "General device failure. (geterr)");
		aflag = 1;
	    }
	}
    } while (inport(cp[apsel]) != DONE && inport(cp[apsel]) != READY && !aflag);
}

qint 
iorec(void)
{
    if (xb_eflag)
	return (0);

    if (cc < COM_APa) {
	if (inportb(cpa[xbsel] + 5) & 0x01) {
	    return (inportb(cpa[xbsel]));
	} else {
	    return (-1);
	}
    } else {
	if (inportb(cpa[xbsel]) & 0x01) {
	    return (inportb(cpa[xbsel] + 1));
	} else {
	    return (-1);
	}
    }
}

/********************************************************************
  Physical Drivers.
 ********************************************************************/
void 
iosend(qint datum)
{
    long    ii;


    if (!xb_eflag) {
	if (cc < COM_APa) {
	    ii = 0;
	    do {
		ii++;
		if (ii > xbtimeout) {
		    showerr("Transmission Time-Out on COM Port.");
		    break;
		}
	    }
	    while (!(inportb(cpa[xbsel] + 5) & 0x20));
	    outportb(cpa[xbsel], datum);
	} else {
	    ii = 0;
	    do {
		ii++;
		if (ii > xbtimeout) {
		    showerr("Transmission Time-Out on COM Port.");
		    break;
		}
	    }
	    while (!(inportb(cpa[xbsel]) & 0x02));
	    outportb(cpa[xbsel] + 1, datum);
	}
    }
}

/********************************************************************
  Error Handling procedures.
 ********************************************************************/
void 
showerr(char eee[])
{
    qint    rn, pn;

    enable();
    rn = xln >> 2;
    pn = (xln & 3) + 1;
    sprintf(xb_err[0], " ");
    sprintf(xb_err[1], "XBUS Error:    Rack(%d),  Position(%d).", rn, pn);
    sprintf(xb_err[2], "    %s", xcaller);
    sprintf(xb_err[3], "    %s", eee);
    sprintf(xb_err[4], " ");
    sprintf(xb_err[5], "");
    xb_eflag = 1;

}

void 
allot16(long bid, long npts)
{
    P(ALLOT16x, "allot16");
    send24(bid);
    send24(npts << 1);
}

void 
send24(long val)
{
    unsigned qint ii;
    unsigned long jj;

    if (!ap_eflag) {
	jj = aptimeout;
	do {
	    jj--;
	    ii = inport(dspsync[apsel]);
	} while (ii != ACK && jj != 0);
	if (jj == 0) {
	    APerror("General device failure. (send24)");
	} else {
	    outport(dspdat[apsel], val);
	    outport(dspsync[apsel], LOW_UP);

	    jj = aptimeout;
	    do {
		jj--;
		ii = inport(dspsync[apsel]);
	    } while (ii != ACK && jj != 0);
	    if (jj == 0) {
		APerror("General device failure. (send24)");
	    } else {
		outport(dspdat[apsel], val >> 16);
		outport(dspsync[apsel], HIGH_UP);
	    }
	}
    }
}

/********************************************************************
  DD1 Procedures
 ********************************************************************/
void 
DD1clear(qint din)
{
    getxln(din, DD1_CODE, "DD1clear(dn)");
    shortform(DD1_CLEAR);
}

void 
DD1go(qint din)
{
    getxln(din, DD1_CODE, "DD1go(dn)");
    shortform(DD1_GO);
}

void 
DD1stop(qint din)
{
    getxln(din, DD1_CODE, "DD1stop(dn)");
    shortform(DD1_STOP);
}

void 
DD1arm(qint din)
{
    getxln(din, DD1_CODE, "DD1arm(dn)");
    shortform(DD1_ARM);
}

void 
DD1mode(qint din, qint mcode)
{
    getxln(din, DD1_CODE, "DD1mode(dn...");
    cmd[0] = DD1_MODE;
    cmd[1] = mcode;
    cmd[2] = 0;
    standform(cmd, 3);
}

void 
DD1srate(qint din, float srate)
{
    unsigned qint v;
    getxln(din, DD1_CODE, "DD1srate(dn...");
    v = (qint) ((10.0 * srate) + 0.5);
    cmd[0] = DD1_SRATE;
    cmd[1] = v;
    cmd[2] = v >> 8;
    standform(cmd, 3);
}

void 
DD1clkin(qint din, qint scode)
{
    getxln(din, DD1_CODE, "DD1clkin(dn...");
    cmd[0] = DD1_CLKIN;
    cmd[1] = scode;
    cmd[2] = 0;
    standform(cmd, 3);
}

void 
DD1clkout(qint din, qint dcode)
{
    getxln(din, DD1_CODE, "DD1clkout(dn...");
    cmd[0] = DD1_CLKOUT;
    cmd[1] = dcode;
    cmd[2] = 0;
    standform(cmd, 3);
}

void 
DD1npts(qint din, long npts)
{
    getxln(din, DD1_CODE, "DD1npts(dn...");
    cmd[0] = DD1_NPTS;
    cmd[1] = npts;
    cmd[2] = npts >> 8;
    cmd[3] = npts >> 16;
    cmd[4] = npts >> 24;
    standform(cmd, 5);
}

void 
DD1mtrig(qint din)
{
    getxln(din, DD1_CODE, "DD1mtrig(dn)");
    shortform(DD1_MTRIG);
}

void 
DD1strig(qint din)
{
    getxln(din, DD1_CODE, "DD1strig(dn)");
    shortform(DD1_STRIG);
}

qint 
DD1status(qint din)
{
    qint    val;

    getxln(din, DD1_CODE, "DD1status(dn)");
/*  iosend(xln);
  iosend(DD1_STATUS);
  val=1;             */

    tdtdisab();
    shortform(DD1_STATUS);
    val = (qint) get8();
    enable();
    return (val);
}

void 
DD1reps(qint din, unsigned qint nreps)
{
    getxln(din, DD1_CODE, "DD1reps(dn...");
    cmd[0] = DD1_REPS;
    cmd[1] = nreps;
    cmd[2] = nreps >> 8;
    standform(cmd, 3);
}

qint 
DD1clip(qint din)
{
    qint    val;

    getxln(din, DD1_CODE, "DD1clip(dn)");
    tdtdisab();
    shortform(DD1_CLIP);
    val = (qint) get8();
    enable();
    return (val);
}

void 
DD1clipon(qint din)
{
    getxln(din, DD1_CODE, "DD1clipon(dn)");
    shortform(DD1_CLIPON);
}

void 
DD1echo(qint din)
{
    getxln(din, DD1_CODE, "DD1echo(dn)");
    shortform(DD1_ECHO);
}

void 
DD1tgo(qint din)
{
    getxln(din, DD1_CODE, "DD1tgo(dn)");
    shortform(DD1_TGO);
}

/********************************************************************
  Form Transfer Procedures.
 ********************************************************************/
void 
shortform(qint val)
{
    qint    i, j;
    long    k;

    if (!xb_eflag) {
	j = 0;
	do {
	    cmd[0] = val;
	    j++;
	    iosend(xln & 0x7f);
	    iosend(val);
	    k = 0;
	    do {
		i = iorec();
		k++;
	    } while (i < 0 && k < xbtimeout);

	    if (i != SLAVE_ACK)
		processerr(i, j);

	} while (i != SLAVE_ACK && j <= XB_MAX_TRYS && !xb_eflag);
    }
}


void 
standform(unsigned char bufp[], qint n)
{
    qint    i, j, x, cs;
    long    k;

    if (!xb_eflag) {
	if (n > 63) {
	    showerr("Too many datum being moved with Standard Form.");
	} else {
	    j = 0;
	    n++;
	    do {
		j++;
		cs = 0;
		iosend(xln & 0x7f);
		iosend(0x40 | n);
		for (x = 0; x < (n - 1); x++) {
		    iosend(bufp[x]);
		    cs += (qint) bufp[x];
		}
		iosend(cs);

		k = 0;
		do {
		    i = iorec();
		    k++;
		} while (i < 0 && k < xbtimeout);

		if (i != SLAVE_ACK)
		    processerr(i, j);

	    } while (i != SLAVE_ACK && j <= XB_MAX_TRYS && !xb_eflag);
	}
    }
}

/******************************************************************
  Pushes Integer variable or array on AP stack.  Npts is
  the number of elements.  Use npts==0 for scalars.
  ----------------------------------------------------------------**/

void 
push16(qint buf[], long npts)
{
    long    adr;

    P(PUSHx, "push16");
    adr = rec24();
    send24(npts << 2);
    SendData(buf, adr, npts);
    cmdout(INT_DSPx);
}

void 
trash(void)
{
    P(TRASHx, "trash");
}

/* Play/Record                  */

void 
play(qint dbn)
{
    P(PLAYx, "play");
    send24(dbn);
}

unsigned char 
get8(void)
{
    qint    i;
    long    k;

    if (xb_eflag)
	return (0);

    k = 0;
    do {
	i = iorec();
	k++;
    } while (i < 0 && k < xbtimeout);
    if (i < 0) {
	showerr("Device not responding with byte value after SLAVE_ACK.");
	i = 0;
    }
    return ((unsigned char) i);
}

void 
P(qint c, char idstr[])
{
    caller = (char *) idstr;

    cmdout(c);
}

void 
processerr(qint li, qint ne)
{
    long    x;
    qint    i, j;
    char    sss[100];

    switch (li) {
    case ARB_ERR:
	{
	    if (ne > XB_MAX_TRYS) {
		XB1flush();
		showerr("Communication errors.");
		break;
	    } else {
		XB1flush();
	    }
	    break;
	}

    case SLAVE_ERR:
	{
	    tdtdisab();
	    j = 0;
	    x = 0;
	    do {
		i = iorec();
		if (i > 0) {
		    sss[j] = (i);
		    j++;
		    x = 0;
		}
		x++;
	    } while (i != 0 && j < 200 && x < xbtimeout);
	    sss[j] = 0;
	    enable();
	    showerr(sss);
	    break;
	}

    default:
	{
	    if (ne > XB_MAX_TRYS)
		showerr("No XBUS device resonding at XBL accessed.");
	    break;
	}
    }
}

long 
rec24(void)
{
    unsigned qint ii;
    unsigned long jj, ll, hh;

    if (ap_eflag)
	return (0);

    if (mrmode)
	return (0);

    jj = aptimeout;
    do {
	jj--;
	ii = inport(dspsync[apsel]);
    } while (ii != LOW_UP && jj != 0);
    if (jj == 0) {
	APerror("General device failure. (rec24)");
	return (0);
    }
    ll = inport(dspdat[apsel]);
    outport(dspsync[apsel], ACK);

    jj = aptimeout;
    do {
	jj--;
	ii = inport(dspsync[apsel]);
    } while (ii != HIGH_UP && jj != 0);
    if (jj == 0) {
	APerror("General device failure. (rec24)");
	return (0);
    }
    hh = inport(dspdat[apsel]) & 0xff;
    outport(dspsync[apsel], ACK);

    hh = hh << 16;
    return (hh | ll);
}

/******************************************************************
  Interface to DataOut. Performs control of AP"s DMA and
  handles LONGINT number of data transfers.
  ----------------------------------------------------------------**/

void 
SendData(qint buf[], long adr, long nwds)
{
    if (!ap_eflag) {
	outport(dsppcrx[apsel], 0x021B);
	outportb(dspadrx[apsel], (adr >> 16) & 0xFF);
	outport(dspadr[apsel], adr & 0xFFFF);

	DataOut((unsigned qint) _FP_SEG(buf),
	    (unsigned qint) _FP_OFF(buf),
	    (unsigned qint) dspdat[apsel],
	    (unsigned qint) nwds);

	outport(dsppcrx[apsel], 0x0203);
    }
}

void 
getxln(qint din, qint dtype, char descrip[])
{
    xln = xbcode[dtype][din][xbsel];
    xcaller = (char *) descrip;
    if (!xln && !xb_eflag) {
	showerr("  Non-present device referenced.");
    }
}

void 
tdtdisab(void)
{
    if (!xb_eflag)
	disable();
}

void 
XB1flush(void)
{
    qint    i;

    for (i = 0; i < 20; i++)
	iosend(ERR_ACK);
    for (i = 0; i < 20; i++)
	iosend(SNOP);

    i = 1000;
    do {
	i--;
	if (i <= 0) {
	    showerr("Unable to flush serial line.");
	    break;
	}
    } while (iorec() >= 0);
}

void 
DataIn(unsigned qint ioport, unsigned qint qseg, unsigned qint qofs, unsigned qint count)
{
    long    i;
    qint   *buf;

    buf = (qint *) _MK_FP(qseg, qofs);
    for (i = 0; i < count; i++)
	buf[i] = inport(ioport);
}

void 
DataOut(unsigned qint qseg, unsigned qint qofs, unsigned qint ioport, unsigned qint count)
{
    long    i;
    qint   *buf;

    buf = (qint *) _MK_FP(qseg, qofs);
    for (i = 0; i < count; i++)
	outport(ioport, buf[i]);
}

void 
tdt_record(qint dbn)
{
    P(RECORDx, "record");
    send24(dbn);
}

/******************************************************************
  Pops Integer scalar or buffer from top of stack.
  ----------------------------------------------------------------**/
void 
pop16(qint buf[])
{
    long    adr, npts;

    P(DSP_INTx, "pop16");
    cmdout(POPx);
    adr = rec24();
    npts = rec24();
    ReceiveData(buf, adr, npts >> 2);
}

/******************************************************************
  Interface to DataIn. Performs control of AP"s DMA and
  handles LONGINT number of data transfers.
  ----------------------------------------------------------------**/
void 
ReceiveData(qint buf[], long adr, long nwds)
{
    if (!ap_eflag) {
	outport(dsppcrx[apsel], 0x021b);
	outportb(dspadrx[apsel], (adr >> 16) & 0xFF);
	outport(dspadr[apsel], adr & 0xFFFF);

	DataIn(dspdat[apsel], _FP_SEG(buf), _FP_OFF(buf), (unsigned qint) nwds);

	outport(dsppcrx[apsel], 0x0203);

	(void) inport(dspdat[apsel]);
    }
}

void 
qpush16(long bid)
{
    P(QPUSH16x, "qpush16");
    send24(bid);
}

void 
dropall(void)
{
    P(DROPALLx, "dropall");
}

void 
qpop16(long bid)
{
    P(QPOP16x, "qpop16");
    send24(bid);
}
