typedef int far *qintptr;
typedef char qstring[50];

#define	QBYTE	      0x01
#define	QWORD         0x02
#define	QINT          0x12
#define	QLINT         0x04
#define	QREAL         0x14
#define	QDREAL        0x08
#define	QLDREAL       0x0A

#define	QAD           0x100
#define	QADx          0x101
#define	QDA           0x200
#define	QDAx          0x201
#define	QAP           0x300
#define	QAPx          0x301
#define	QDA1          0x400
#define	QDA1x         0x401
#define	QDISK         0x500

#define QCHAN_A       0
#define QCHAN_B       100
#define QDUAL         200
#define QDELAYED      300
#define QIMMED        400

#define	Q00DB         0x03
#define Q06DB         0x02
#define Q10DB         0x01
#define Q20DB         0x00

#define	QON           0x01
#define QOFF          0x00

#define QEXT_LOW      0
#define QEXT_HI       1
#define QEXT_RISE     2
#define QEXT_FALL     3
#define QCMP_RISE     4
#define QCMP_FALL     5
#define QCMP_SAME     6
#define QEB_TRIG      7
#define QLOOP         8

#define QDEFAULTTYPE  QINT
#define QALL          -1
#define QFLAG         0xFF
#define Q86           1
#define Q286          2

#define QDEFBS        10000
#define QCOMMAND      0x0
#define QCOUNT        0x1
#define QCLOCK        0x4
#define QRAM          0x6
#define QAINSEL       0x8
#define QAINPAR       0x9
#define QPAGE         0xA
#define QCOMVAL       0xB
#define QPDDWSEL      0xC
#define QSEPERATE     0xD
#define QTRIGGER      0xE
#define QOVERFLOW     0x1
#define QINFO         0x2
#define QSTATUS       0x3
#define QRSTOVER      0xF

#define QXREAD        0x10
#define QXWRITE       0x20
#define QS_HON        0x40
#define QA_DON        0x80
#define QCOMPARE      0x08
#define QLAST         0x04
#define QMARK         0x01
#define QMANMK        0x02
#define QRAMWR        0x04
#define QRAMRD        0x08
#define QACT          0x80
#define QRAGRUN       0x80

#define QDA_A         0x04
#define QDA_B         0x40

#define QDA1_CMD      0x0C
#define QDA1_SINK     0x0D
#define QDA1_STAT     0x00
#define QDA1_CLK      0x06
#define QDA1_REPA     0x00
#define QDA1_DATA     0x08
#define QDA1_ADDA     0x0A
#define QDA1_REPB     0x05
#define QDA1_DATB     0x01
#define QDA1_ADDB     0x03

#define QDA1_DMA      0x08
#define QDA1_LOAD     0x04
#define QDA1_STPA     0x10
#define QDA1_STPB     0x40
#define QDA1_GOA      0x20
#define QDA1_GOB      0x80
#define QDA1_MANA     0x01
#define QDA1_MANB     0x02


/*******    DATA CONVERSION    *********/
unsigned Qactive(int qdevice);
void    Qgo(int qdevice);
void    Qsetcnt(int qdevice, long qcnt, char qcaller[]);
void    Qsrate(int qdevice, float qperiod, char qcaller[]);
void    Qconvert(long qbuf, long qpnts, float qrate);
void    Qstop(int qdevice, int qmode);
void    Qtrig(int qdevice, int qtmode);

/*******    QAD specific procedures	 *******/
void    QADchan(int qdevice, int qpddw, int qchan);
void    QADcompare(int qdevice, int qpddw, int qflag);
void    QADgain(int qdevice, int qpddw, int qgain);
void    QADisss(int qdevice, float qisss);
void    QADlast(int qdevice, unsigned qpddw);
void    QADlevel(int qdevice, int qvalue);
unsigned QADoverflow(int qdevice);
void    QADsamhold(int qdevice, unsigned qshmode);

/*******    QDA1 SPECIFIC procedures     *********/
void    QDA1reps(int qdevice, unsigned qrepa, unsigned qrepb);
void    QDA1setsubs(int qdevice, unsigned qns);

/*******    QDA2 SPECIFIC procedures     *********/
long    QDAmode(long qbuf, int qmde);

/*******    BUFFER MANAGMENT     *********/
long    Q(int buf[]);
void    Qdeclare(int qid, long qpts, unsigned qtype, unsigned qdevice, char qname[]);
void    Qfind(int qbuf, int qpts);
void    Qforget(int qid);

void    QdevpcP(unsigned ioport, unsigned qseg, unsigned qofs, unsigned count);
void    QdevpcA(unsigned ioport, unsigned qseg, unsigned qofs, unsigned count);
void    QpcdevP(unsigned qseg, unsigned qofs, unsigned ioport, unsigned count);
void    QpcdevA(unsigned qseg, unsigned qofs, unsigned ioport, unsigned count);

void    Qdevdisk(long qbuf1, long qbuf2, long qpnts);
void    Qdiskdev(long qbuf1, long qbuf2, long qpnts);
void    Qdskdsk(long qbuf1, long qbuf2, long qpnts);
void    Qdiskpc(long qbuf1, long qbuf2, long qpnts);
void    Qpcdisk(long qbuf1, long qbuf2, long qpnts);
void    Qdevdev(long qbuf1, long qbuf2, long qpts);
void    Qdevpc(long qbuf1, long qbuf2, long qpnts);
void    Qpcdev(long qbuf1, long qbuf2, long qpnts);
void    QpcQDA1(long qbuf1, long qbuf2, long qpnts);
void    QdskQDA1(long qbuf1, long qbuf2, long qpnts);
void    QdevQDA1(long qbuf1, long qbuf2, long qpnts);

void    Qmove(long qbuf1, long qbuf2, long qpnts);
void    Qpurge(int qdevice);
unsigned Qset(long qbuf);
void    Qsplit(long qbuffer, long qpts, unsigned qchans, qintptr qpoints[]);

/*******    INITIALIZATION     *********/
void    Qinit(int qdevice);
void    Qstart(void);

/*******    Misc Stuff     *********/
void    Qerror(char qemess[], char qpro[]);
unsigned Qpointer(int qdevice, char qcaller[]);
