/* showwave.c */

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include "waved.h"
#include "video.h"
#include "fk.h"

#define Ctrl_C          3
#define ESC             27

int     chkevent();
int     menu();
void    g_cursor_del();
void    g_cursor_init();
void    g_cursor_move();
void    g_move();
void    g_draw();
void    ins_mark_sm();
void    ins_new_mark_sm();
void    del_mark_sm();
void    goto_mark_sm();
void    showwindow_sm();
void    setup_sm();
void    curstime();
void    set_mmv();
void    get_mouse_location();
void    windpos();
void    playquery();
void    pan_left_sm();
void    pan_right_sm();
void    window_edit();
void    replay();
void    chk_toolbar_sm();

int scrollrate = 0;
int pagedelta = 0;

static void drawwave();
static void cursor_off();
static void cursor_on();
static void show_scroll_mark();

static int s_bits, s_zero, s_nchn;
static int d_xpix, d_yrng, d_xoff, d_xend, d_ytop, d_ybot, d_np;
static int c_on, c_hh, c_yy, c_so, c_mn, c_mx, c_mv;
static int m_yy, m_mn, m_mx, m_ch;
static long sp, ep, lp;
static long s_npts, s_rnge;
static SIGNAL *s;

void
showwave(sn)
int     sn;
{
    int     i, nb, hs, rd, eb, key, mx, my, sm, iw = 0;
    static char *mis[] = {
    	"Edit", "Modify", "Calc", "Play", "Set", "Help", ""
    };

    s = &sig[sn];
    s_npts = s->siglen;
    s_nchn = limit(1, s->sgnchn, MAX_CHAN);
    s_zero = s->sigzer;
    s_bits = s->sgbits;
    s_rnge = 1L << s_bits;
    for (i = 0; i < s_nchn; i++)
        s->sigbuf[s_npts * s_nchn + i] = s->sigzer;
    d_np = scrszx;

    scrollmode = 1;
    set_mmv(1);
    setup_sm();
    scrollrate = 0;
    sm = d_np - 1;
    ep = s_npts - sm;
    sp = limit(0, curspnt - scroff, ep);
    pagedelta = d_np / 2;
    hs = pagedelta / 8;
    mx = d_np / 2;
    my = 0;
    rd = 1;
    lp = sp;

    while (scrollmode) {
	if (ep <= 0)
	    scrollrate = 0;
	if (scrollrate != 0)
	    sp += scrollrate * 8;
	if (sp < 0) {
	    beep();
	    c_so += sp;
	    if (c_so < 0)
	    	c_so = 0;
	    sp = 0;
	    scrollrate = 0;
	    if (iw)
	        c_so = mx;
            iw = 0;          
	}
	if (sp > ep) {
	    beep();
	    c_so += sp - ep;
	    if (c_so > sm)
	    	c_so = sm;
	    sp = ep;
	    scrollrate = 0;
	    if (iw)
	        c_so = mx;
	    iw = 0;
	}
        eb = sp % 8;
	if (eb) {
	    if ((ep - sp) > c_mn || c_so <= c_mn) {
		c_so += eb;
		sp -= eb;
	    } else if (sp < ep) {
                c_so -= (ep - sp);
                sp = ep;
	    }
	}
        nb = (lp - sp) / 8;
        eb = (lp - sp) % 8;
	if (eb != 0 || nb > hs || nb < -hs)
	    rd = 1;
	lp = sp;
	if (rd) {
            showdata();
            rd = 0;
	} else if (nb > 0) {
	    if (c_on)
		cursor_off();
	    gr_xshft(d_ytop, d_ybot, nb);
	    d_xpix = 8 * nb;
	    d_xoff = 0;
	    d_xend = d_xoff + d_xpix - 1;
	    drawwave();
            c_so = d_np / 2;
	} else if (nb < 0) {
	    if (c_on)
		cursor_off();
	    gr_xshft(d_ytop, d_ybot, nb);
	    d_xpix = -8 * nb;
	    d_xend = d_np;
	    d_xoff = d_np - d_xpix;
	    drawwave();
            c_so = d_np / 2;
	}

        if (iw && (mx < c_mn || mx > c_mx) && scrollrate == 0) {
            if (mx < c_mn && sp > 0)
                scrollrate = (mx - c_mn) / 8;
            if (mx > c_mx && sp < ep)
                scrollrate = (mx - c_mx) / 8;
        }
        if (c_so < 0 || c_so > sm) {
	    c_so = limit(0, c_so, sm);
	    scrollrate = 0;
	    iw = 0;
            cursor_on();
            show_scroll_mark();
        }

	if (chkevent() || scrollrate == 0) {
            if (!c_on || m_ch) {
                cursor_on();
                show_scroll_mark();
            }
            key = menu("SCROLL MODE", mis);
            curspnt = sp + c_so;
            scroff = c_so;
            set_mmv(0);
	    switch (key) {
	    case Ctrl_C:
	    	thru = 1;
	    	return;
	    case MMV:		/* mouse moved */
                get_mouse_location(&mx, &my);
                iw = (my >= win[aw].winy1 && my <= win[aw].winy2);
                if (iw) {
                    c_so = mx;
                    c_mv = 1;
                }
		break;
	    case MDL:		/* mouse down left */
                get_mouse_location(&mx, &my);
                iw = (my >= win[aw].winy1 && my <= win[aw].winy2);
                if (iw) {
                    maximize = !maximize;
                    setup_sm();
                    showall();
                }
                chk_toolbar_sm(mx, my);
                scrollrate = 0;
		break;
	    case MDR:		/* mouse down right */
                get_mouse_location(&mx, &my);
                iw = (my >= win[aw].winy1 && my <= win[aw].winy2);
                if (iw) {
                    ins_new_mark_sm();
                } else {
                    replay();
                }
                scrollrate = 0;
		break;
	    case FK_Home:
	    case FK_Ctrl_Home:
		sp = 0;
		c_so = 0;
		c_mv = 1;
		break;
	    case FK_End:
	    case FK_Ctrl_End:
		sp = ep;
		c_so = d_np - 1;
		c_mv = 1;
		break;
	    case FK_PgUp:
                pan_left_sm();
		break;
	    case FK_PgDn:
                pan_right_sm();
		break;
	    case FK_Ins:
		ins_mark_sm();
		break;
	    case '0':
		ins_new_mark_sm();
		break;
	    case FK_Del:
		del_mark_sm();
		break;
	    case FK_Left_Arrow:
		c_so--;
		c_mv = 1;
		break;
	    case FK_Right_Arrow:
		c_so++;
		c_mv = 1;
		break;
	    case FK_Ctrl_Left:
		c_so -= 50;
		c_mv = 1;
		break;
	    case FK_Ctrl_Right:
		c_so += 50;
		c_mv = 1;
		break;
	    case FK_F1:
                showhelp();
		scrollrate = 0;
		break;
            case FK_F2:
                sigmsg(aw);
		scrollrate = 0;
                break;
	    case FK_F4:
                maximize = !maximize;
                setup_sm();
                showall();
		scrollrate = 0;
                break;
	    case FK_F5:
	    case ESC:		/* Escape */
	    case '~':
                window_edit();
		break;
            case FK_F6:
        	win[aw].winmod = !win[aw].winmod;
        	showwindow_sm();
        	break;
	    case ',':
	    case '<':		/* scroll left */
		if (scrollrate > -8)
		    scrollrate--;
		break;
	    case '.':
	    case '>':		/* scroll right */
		if (scrollrate < 8)
		    scrollrate++;
		break;
	    case '4':		/* shift left arrow */
		c_so -= 10;
		c_mv = 1;
		break;
	    case '6':		/* shift right arrow */
		c_so += 10;
		c_mv = 1;
		break;
	    case 'E':
		editquery();
                if (s_npts == 0) {
                    scrollmode = 0;
                    return;
                }
                sp = limit(0, curspnt - scroff, ep);
                c_so = scroff;
		c_mv = 1;
		break;
	    case 'C':
		calcquery();
		c_mv = 1;
		break;
	    case 'G':
		goto_mark_sm();
		break;
	    case 'H':
                showhelp();
		scrollrate = 0;
		break;
	    case 'M':
                modquery();
		c_mv = 1;
		break;
	    case 'P':
		playquery(1);
		break;
	    case 'S':
		setup();
		break;
	    case '\f':		/* redraw */
		makescrn();
		scrollrate = 0;
		break;
	    case '\r':		/* repeat */
	    case '"':
		replay();
		break;
	    default:
		scrollrate = 0;
	    }
            set_mmv(1);
	    if (s_zero != s->sigzer) {
		s_zero = s->sigzer;
		rd = 1;
	    }
	    if (s_bits != s->sgbits) {
		s_bits = s->sgbits;
		s_rnge = 1L << s_bits;
		rd = 1;
	    }
            if (c_mv) {
                scrollrate = 0;
                while (c_so < c_mn && sp > 0) {
                    sp--;
                    c_so++;
                }
                while (c_so > c_mx && sp < ep) {
                    sp++;
                    c_so--;
                }
                cursor_on();
            }
	}
    }
    set_mmv(0);
}

static void
drawchan(int ichn)
{
    int     x, y, yy, icount, yval, i;
    long    y0, y1, y2, dy;
    SIGPTR  pbuf;

    s->sigbuf[s_npts * s_nchn + ichn] = s_zero;
    pbuf = &s->sigbuf[(sp + d_xoff) * s_nchn + ichn];
    if (win[aw].winmod) {
        y1 = d_yrng / s_nchn;
        dy = y1;
    } else {
        y1 = d_yrng;
        dy = 0;
    }
    y2 = s_rnge - 1;
    y0 = y1 / 2 + ichn * dy ;
    yval = (sp == 0) ? s_zero : pbuf[-s_nchn];
    yy = (int) (y0 - ((yval - s_zero) * y1) / y2);
    y = d_ytop + limit(0, yy, d_yrng);
    i = 0;
    for (icount = 0; icount < d_xpix; icount++) {
	x = d_xoff + icount;
	g_move(x, y);
	yval = pbuf[i];
	i += s_nchn;
	y = (int) (y0 - ((yval - s_zero) * y1) / y2);
	y = d_ytop + limit(0, y, d_yrng);
	g_draw(x, y, wavcol - ichn);
    }
}

static void
drawwave()
{
    int i;
    
    g_bar(d_xoff, d_ytop, d_xend, d_ybot, wnbgc);
    for(i = 0; i < s_nchn; i++)
        drawchan(i);
}

static void
cursor_on()
{
    g_cursor_init(c_hh, csrcol);
    g_cursor_move(c_so, c_yy);
    c_on = 1;
    c_mv = 0;

    curspnt = sp + c_so;
    curstime();
}

static void
cursor_off()
{
    g_cursor_del();
    c_on = 0;
}

static void
show_scroll_mark()
{
    int     c, col;

    g_bar(0, m_yy, scrszx - 1, d_ybot, wnbgc);
    for (c = 0; c < NMARK; c++) {
        if (s->sigmrk[c] != NOMARK) {
            col = s->sigmrk[c] - sp;
            if (col >= m_mn && col < m_mx) {
                g_drawmark(col, m_yy, c);
            }
	}
    }
    m_ch = 0;
}

void
ins_mark_sm()
{
    int     c;

    putmsg(" INSERT MARK:  Enter letter for mark  ");
    c = getmark(0);
    if (c < 26) {
	s->sigmrk[c] = sp + c_so;
        m_ch = 1;
    }
    clrmsg();
    scrollrate = 0;
}

void
ins_new_mark_sm()
{
    int     c;

    c = newmark();
    if (c < 26) {
	s->sigmrk[c] = sp + c_so;
        m_ch = 1;
    }
    scrollrate = 0;
}

void
del_mark_sm()
{
    int     c;

    putmsg(" DELETE MARK: Enter letter for mark  ");
    c = getmark(0);
    if (c < 26) {
	s->sigmrk[c] = NOMARK;
        m_ch = 1;
    }
    clrmsg();
    scrollrate = 0;
}

void
goto_mark_sm()
{
    int     c, cp;

    putmsg(" GOTO MARK: enter letter for mark");
    c = getmark(0);
    if (c < NMARK) {
	cp = s->sigmrk[c];
	if (cp != NOMARK) {
	    scroff = d_np / 2;
            c_so = scroff;
            sp = cp - c_so;
            m_ch = 1;
        }
    }
    clrmsg();
    scrollrate = 0;
}

void
showwindow_sm()
{
    cursor_off();
    g_bar(d_np, d_ytop, scrszx - 1, d_ytop + d_yrng, wnbgc);
    d_xpix = d_np;
    d_xoff = 0;
    d_xend = d_xoff + d_xpix - 1;
    drawwave();
    if (!maximize && fsw == lsw)
        g_bar(0, d_ybot, scrszx - 1, msgy - 12, scbgc);
    cursor_on();
    show_scroll_mark();
    (void) chkevent(); /* updates windows */
}

void
setup_sm()
{
    windpos(aw);
    d_ytop = win[aw].winy1;
    d_ybot = win[aw].winy2;
    d_np = (s_npts >= scrszx) ? scrszx : s_npts + 1;
    d_yrng = d_ybot - d_ytop - 20;  /* moved down 1 line to avoid LCC bug */

    m_yy = d_ybot - 20;
    m_mn = 4;
    m_mx = d_np - 4;
    m_ch = 0;

    c_on = 0;
    c_mv = 0;
    c_hh = d_yrng - 1;
    c_yy = d_ytop;
    c_so = scroff;
    c_mn = scrszx / 8;
    c_mx = scrszx - scrszx / 8;

    scrollrate = 0;
}

void
pan_left_sm()
{
    if (sp > 0)
        c_mv = 1;
    sp -= pagedelta;
    if (sp < 0)
        sp = 0;
}

void
pan_right_sm()
{
    if (sp < ep)
        c_mv = 1;
    sp += pagedelta;
    if (sp > ep)
        sp = ep;
}

void
window_edit()
{
    scrollmode = 0;
    scrollrate = 0;
}
