/* $Id: wavtdt.h%v 1.15 1994/05/27 15:06:42 sulli Exp sulli $ */

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#ifndef TURBOC
#include <malloc.h>
#define outportb(a,b) (void)_outp((unsigned) (a), (int) (b))
#define outport(a,b) (void)_outpw((unsigned) (a), (int) (b))
#define inportb(a) _inp(a)
#define inport(a) _inpw(a)
#define enable() _enable()
#define disable() _disable()
#else
#include <alloc.h>
unsigned char inportb(unsigned int addr);
unsigned int  inport(unsigned int addr);
#define _MK_FP( seg,ofs )( (void _seg * )( seg ) +( void near * )( ofs ))
#define FP_SEG( fp )( (unsigned )( void _seg * )( void far * )( fp ))
#define FP_OFF( fp )( (unsigned )( fp ))
#endif

/* xbdrv.h */
#undef COMP32

#ifdef COMP32
#define qint short int
#else
#define qint int
#endif

#ifndef SIGPTRDEF
#ifdef HUGE_PTR
typedef short huge *SIGPTR;
#else
typedef short *SIGPTR;
#endif /* HUGE_PTR */
#define SIGPTRDEF
#endif  /* SIGPTRDEF */

/* #defines	*/

#define        PLAYx       201
#define        RECORDx     202

/**********************************************************
  User programmable control constants
 **********************************************************/

#define XB_MAX_DEV_TYPES      32
#define XB_MAX_OF_EACH_TYPE   16
#define XB_MAX_NUM_RACKS     120
#define XB_TIMEOUT          3000
#define XB_MAX_TRYS            3
#define XB_WAIT_FOR_ID        40

qint apinit(qint devtype);
int input_TDTII(int *buf, long npts, long rate);
void allot16(long bid, long npts);
void APerror(char *estr);
float clockrate_to_srate(long clockrate);
void cmdout(qint cmd);
void DataIn(unsigned qint ioport, unsigned qint qseg,
  unsigned qint qofs, unsigned qint count);
void DataOut(unsigned qint qseg, unsigned qint qofs,
  unsigned qint ioport, unsigned qint count);
unsigned char get8(void);
void GetErr(void);
void getxln(qint din, qint dtype, char descrip[]);
int  init_iod_TDTII(void);
int input_TDTII(int *buf, long npts, long rate);
void iosend(qint datum);
qint iorec( void );
int output_TDTII(int *buf, long npts, long rate);
void play(qint dbn);
void pop16(qint buf[]);
void processerr( qint li, qint ne);
void push16(qint buf[], long npts);
void P(qint cmd, char idstr[]);
void qpush16(long bid);
long rec24(void);
void ReceiveData(qint buf[], long adr, long nwds);
void send24(long val);
void shortform(qint val);
void showerr( char eee[]);
void standform( unsigned char bufp[], qint n);
void SendData(qint buf[], long adr, long nwds);
void tdtdisab(void);
void trash(void);
qint XB1init(qint cptr);
void XB1flush(void);
void tdt_record(qint dbn);
void stop_TDTII(void);
void dropall(void);
void popdisk16(char *fname);

int init_iod4(void);
int input_adc4(SIGPTR buf, long npts, long rate);
int output_dac4(SIGPTR buf, long npts, long rate);
void stop_iod4(void);

#define SRATE_DIVISOR	1000000.0	/* Divisor to convert clockrate	*/
					/* from points per second to	*/
					/* points per usec.		*/
#define TDT_BUF1      	 10		/* Buffer ID for 1st buffer.	*/
#define TDT_BUF2      	 11		/* Buffer ID for 2nd buffer.	*/
#define CPS     1193180L

/* Misc. Constants */
#define        TIMEOUT     10000
#define        TBUFSIZE    5000
#define        PERROR      1
#define        MAXCMDS     300
#define        APa         0x311
#define        APb         0x312
#define       LOW_UP     0x111
#define       HIGH_UP    0x222
#define       ACK        0x333

/* Data Handlers and Startup */
#define    INITx      1
#define    PUSHx      2
#define    POPx       3
#define    QPOPFx     4
#define    QPUSHFx    5
#define    SNG_DSPx   6
#define    DSP_SNGx   7
#define    INT_DSPx   8
#define    DSP_INTx   9
#define    BLOCKx     10
#define    NOBLOCKx   11
#define    SWAPx      12
#define    QDUPx      13
#define    DROPx      14
#define    DROPALLx   15
#define    ALLOTFx    16
#define    TRASHx     17
#define    EXTRACTx   18
#define    CATx       19
#define    CATNx      20
#define    DUPNx      21
#define    ALLOT16x   22
#define    QPOP16x    23
#define    QPUSH16x   24
#define    TOTOPx     25
#define    QPUSHPARTFx  26
#define    QPUSHPART16x 27
#define    QPOPPARTFx   28
#define    QPOPPART16x  29
#define    DPUSHx		   	30
#define    MAKEDAMA16x  31
#define    MAKEDAMAFx   32
#define    DAMA2DAMAx   33
#define    DEALLOTx     34
#define    REDUCEx      35

/*   Handshake Codes  */
#define       READY      1110
#define       RECEIVED   1120
#define       DATARDY    1130
#define       ERRFLAG    1140
#define       ERRACK     1150
#define       CHARRDY    1160
#define       XFERERR    1170
#define       DONE       1190
#define       STOPMAC    1310
#define       MACACT     1320

extern         qint        qapsel;
extern         qint        ap_eflag,ap_emode;
extern         char        ap_err[10][100];

/**********************************************************
  Device ID codes
 **********************************************************/

#define PA4_CODE       0x01
#define SW2_CODE       0x02
#define CG1_CODE       0x03
#define SD1_CODE       0x04
#define ET1_CODE       0x05
#define PI1_CODE       0x06
#define UI1_CODE       0x07
#define WG1_CODE       0x08
#define PF1_CODE       0x09
#define TG6_CODE       0x0a
#define PI2_CODE       0x0b
#define WG2_CODE       0x0c

#define DA1_CODE       0x10
#define AD1_CODE       0x11
#define DD1_CODE       0x12
#define DA2_CODE       0x13
#define AD2_CODE       0x14
#define AD3_CODE       0x15
#define DA3_CODE       0x16
#define PD1_CODE       0x17

/**********************************************************
  Global communication/control constants
 **********************************************************/

#define COM1     1
#define COM2     2
#define COM3     3
#define COM4     4
#define COM_AP2  5
#define COM_AP2x 6
#define COM_APa  5
#define COM_APb  6
#define USE_DOS  0

#define COM1base 0x3f8
#define COM2base 0x2f8
#define COM3base 0x3e8
#define COM4base 0x2e8
#define APabase  0x230
#define APbbase  0x250

#define SNOP          0x00
#define VER_REQUEST   0x06
#define XTRIG		      0x07
#define IDENT_REQUEST 0x08
#define HOST_RTR      0x09

#define ARB_ERR       0xC0
#define HOST_ERR      0xC1
#define ERR_ACK       0xC2
#define SLAVE_ACK     0xC3
#define HARD_RST      0xC5
#define SLAVE_ERR     0xC6
#define BAUD_LOCK     0xCA
#define ARB_ACK       0xCB
#define ARB_ID        0xCC
#define ARB_RST       0xCD
#define GTRIG         0xD2
#define LTRIG         0xD3
#define ARB_VER_REQ   0xD4

/**********************************************************
  DD1 Drivers
 **********************************************************/
#define DD1_GO        0x11
#define DD1_STOP      0x12
#define DD1_ARM       0x13
#define DD1_MODE      0x14
#define DD1_SRATE     0x15
#define DD1_CLKIN     0x16
#define DD1_CLKOUT    0x17
#define DD1_NPTS      0x18
#define DD1_MTRIG     0x19
#define DD1_STRIG     0x1a
#define DD1_STATUS    0x1b
#define DD1_REPS      0x1c
#define DD1_CLIP      0x1d
#define DD1_CLEAR     0x1e
#define DD1_CLIPON    0x1f
#define DD1_ECHO      0x20
#define DD1_TGO	      0x21

void DD1clear( qint din);
void DD1go( qint din);
void DD1stop( qint din);
void DD1arm( qint din);
void DD1mode( qint din, qint mcode);
  #define ALL       0x0f
  #define DUALDAC   0x03
  #define DAC1      0x01
  #define DAC2      0x02
  #define DUALADC   0x0c
  #define ADC1      0x04
  #define ADC2      0x08
  #define FASTDAC   0x10
void DD1srate( qint din, float srate);
void DD1clkin( qint din, qint scode);
  #define INTERNAL  1
  #define EXTERNAL  2
  #define XCLK1     3
  #define XCLK2     4
void DD1clkout( qint din, qint dcode);
/* See above for XCLK1 and XCLK2 and NONE */
void DD1npts( qint din, long npts);
void DD1mtrig( qint din);
void DD1strig( qint din);
qint DD1status( qint din);
void DD1reps( qint din, unsigned qint nreps);
qint DD1clip( qint din);
void DD1clipon(qint din);
void DD1echo(qint din);
void DD1tgo(qint din);
void qpop16(long bid);

